'use strict';

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _sighCore = require('sigh-core');

var _processPool = require('process-pool');

var _processPool2 = _interopRequireDefault(_processPool);

var _2 = require('./');

var _3 = _interopRequireDefault(_2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

require('source-map-support').install();
require('chai').should();

describe('babel plugin', function () {
  // TODO: use a single babel plugin for all tests to avoid all the delays due
  //       to starting subprocesses.
  var procPool;
  beforeEach(function () {
    procPool = new _processPool2.default();
  });
  afterEach(function () {
    procPool.destroy();
  });

  it('compiles a single add event', function () {
    this.timeout(15000);

    var data = 'var pump = () => "pumper"';
    var event = new _sighCore.Event({
      basePath: 'root',
      path: 'root/subdir/file.js',
      type: 'add',
      data: data
    });
    var stream = _sighCore.Bacon.constant([event]);

    return (0, _3.default)({ stream: stream, procPool: procPool }, {
      presets: ['es2015-loose', 'stage-1'],
      plugins: ['transform-es2015-modules-amd']
    }).toPromise(_bluebird2.default).then(function (events) {
      events.length.should.equal(1);

      var _events$ = events[0],
          data = _events$.data,
          sourceMap = _events$.sourceMap;


      data.should.equal('define("subdir/file", [], function () {\n  "use strict";\n\n  var pump = function pump() {\n    return "pumper";\n  };\n});');
      sourceMap.should.have.property('mappings');
      sourceMap.mappings.should.have.length.above(20);
      sourceMap.file.should.equal(event.path);
      sourceMap.sources.should.eql([event.path]);
    });
  });
});
//# sourceMappingURL=index.spec.js.map